Index: /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 103913)
+++ /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 103914)
@@ -836,4 +836,5 @@
 	src/globals/UITextTable.h \
 	src/globals/UITranslator.h \
+	src/globals/UITranslationEventListener.h \
 	src/globals/UIVirtualBoxEventHandler.h \
 	src/globals/UIVirtualBoxClientEventHandler.h \
@@ -1414,4 +1415,5 @@
 	src/globals/UIThreadPool.cpp \
 	src/globals/UITranslator.cpp \
+	src/globals/UITranslationEventListener.cpp \
 	src/globals/UIVersion.cpp \
 	src/globals/UIVirtualBoxEventHandler.cpp \
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 103913)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.cpp	(revision 103914)
@@ -79,4 +79,5 @@
 #include "UIThreadPool.h"
 #include "UITranslator.h"
+#include "UITranslationEventListener.h"
 #include "UIVersion.h"
 #include "UIVirtualBoxClientEventHandler.h"
@@ -223,4 +224,5 @@
     , m_pThreadPoolCloud(0)
     , m_pMediumEnumerator(0)
+    , m_pTranlationEventListener(0)
 {
     /* Assign instance: */
@@ -303,4 +305,6 @@
 
     retranslateUi();
+
+    m_pTranlationEventListener = new UITranslationEventListener(this);
 
     connect(gEDataManager, &UIExtraDataManager::sigLanguageChange,
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h	(revision 103913)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UICommon.h	(revision 103914)
@@ -62,4 +62,5 @@
 class UIMediumEnumerator;
 class UIThreadPool;
+class UITranslationEventListener;
 
 /** QObject subclass containing common GUI functionality. */
@@ -680,4 +681,5 @@
     /** @} */
 
+    UITranslationEventListener *m_pTranlationEventListener;
     /** Allows for shortcut access. */
     friend UICommon &uiCommon();
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UITranslationEventListener.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UITranslationEventListener.cpp	(revision 103914)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UITranslationEventListener.cpp	(revision 103914)
@@ -0,0 +1,53 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UITranslationEventListener class implementation.
+ */
+
+/*
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
+ *
+ * This file is part of VirtualBox base platform packages, as
+ * available from https://www.virtualbox.org.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, in version 3 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses>.
+ *
+ * SPDX-License-Identifier: GPL-3.0-only
+ */
+
+/* Qt includes: */
+#include <QApplication>
+
+/* GUI includes: */
+#include "UITranslationEventListener.h"
+#include "UITranslator.h"
+
+
+
+UITranslationEventListener::UITranslationEventListener(QObject *pParent /* = 0 */)
+    :QObject(pParent)
+{
+    qApp->installEventFilter(this);
+}
+
+bool UITranslationEventListener::eventFilter(QObject *pObject, QEvent *pEvent)
+{
+    if (   !UITranslator::isTranslationInProgress()
+           && pEvent->type() == QEvent::LanguageChange)
+    {
+        //&& (pObject == qApp || pObject == this))
+        emit sigRetranslate();
+    }
+    /* Call to base-class: */
+    return QObject::eventFilter(pObject, pEvent);
+}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UITranslationEventListener.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UITranslationEventListener.h	(revision 103914)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UITranslationEventListener.h	(revision 103914)
@@ -0,0 +1,56 @@
+/* $Id$ */
+/** @file
+ * VBox Qt GUI - UITranslationEventListener class declaration.
+ */
+
+/*
+ * Copyright (C) 2006-2023 Oracle and/or its affiliates.
+ *
+ * This file is part of VirtualBox base platform packages, as
+ * available from https://www.virtualbox.org.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation, in version 3 of the
+ * License.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses>.
+ *
+ * SPDX-License-Identifier: GPL-3.0-only
+ */
+
+#ifndef FEQT_INCLUDED_SRC_globals_UITranslationEventListener_h
+#define FEQT_INCLUDED_SRC_globals_UITranslationEventListener_h
+#ifndef RT_WITHOUT_PRAGMA_ONCE
+# pragma once
+#endif
+
+/* Qt includes: */
+#include <QObject>
+
+#include "UILibraryDefs.h"
+
+class SHARED_LIBRARY_STUFF UITranslationEventListener : public QObject
+{
+    Q_OBJECT;
+
+signals:
+
+    void sigRetranslate();
+
+public:
+
+    UITranslationEventListener(QObject *pParent = 0);
+
+protected:
+
+    bool eventFilter(QObject *pObject, QEvent *pEvent) override final;
+};
+
+#endif /* !FEQT_INCLUDED_SRC_globals_UITranslationEventListener_h */